import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { components, events, renderClassName, EventContextProvider } from 'fastui';
import BootstrapToast from 'react-bootstrap/Toast';
import BootstrapToastContainer from 'react-bootstrap/ToastContainer';
export const Toast = (props) => {
    const { className, title, body, position, openTrigger, openContext } = props;
    const { eventContext, fireId, clear } = events.usePageEventListen(openTrigger, openContext);
    return (_jsx(EventContextProvider, { context: eventContext, children: _jsx(BootstrapToastContainer, { position: position, className: "position-fixed bottom-0 end-0 p-3", children: _jsxs(BootstrapToast, { className: renderClassName(className), show: !!fireId, onClose: clear, children: [_jsx(BootstrapToast.Header, { children: _jsx("strong", { className: "me-auto", children: title }) }), _jsx(BootstrapToast.Body, { children: _jsx(components.AnyCompList, { propsList: body }) })] }) }) }));
};
