import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { asTitle } from '../tools';
import { useClassName } from '../hooks/className';
import { DisplayComp, renderEvent } from './display';
export const DetailsComp = (props) => (_jsx("dl", { className: useClassName(props), children: props.fields.map((field, id) => (_jsx(FieldDetail, { props: props, fieldDisplay: field }, id))) }));
const FieldDetail = ({ props, fieldDisplay }) => {
    const onClick = fieldDisplay.onClick;
    let title = fieldDisplay.title;
    const rest = { mode: fieldDisplay.mode };
    let value;
    if ('type' in fieldDisplay && fieldDisplay.type === 'Display') {
        // fieldDisplay is Display
        value = fieldDisplay.value;
    }
    else if ('field' in fieldDisplay) {
        // fieldDisplay is DisplayLookupProps
        const field = fieldDisplay.field;
        title = title ?? asTitle(field);
        value = props.data[field];
        rest.tableWidthPercent = fieldDisplay.tableWidthPercent;
    }
    const renderedOnClick = renderEvent(onClick, props.data);
    return (_jsxs(_Fragment, { children: [_jsx("dt", { className: useClassName(props, { el: 'dt' }), children: title }), _jsx("dd", { className: useClassName(props, { el: 'dd' }), children: _jsx(DisplayComp, { type: "Display", onClick: renderedOnClick, value: value !== undefined ? value : null, ...rest }) })] }));
};
